#include <stdio.h>
#define 	MAX_PRODUCT_NAME	100 

struct InfoPart {
	unsigned char ProductName[MAX_PRODUCT_NAME+1];
	int Amount;	
	float Price;
} ;
typedef  struct InfoPart MyData;

struct NodeElement {
	MyData val;
	struct NodeElement * next;
} ;

typedef  struct NodeElement Node;


Node * addToHead( Node * head, Node * newE);
Node * addToTail( Node * head, Node * newE);
Node * addInSortedList_SingleField(Node * head, Node * newE);
Node * addInSortedList_MultiField(Node * head, Node * newE);
Node * FindByNext( Node * head, Node * nextPtr );
Node * FindByPrice( Node * head, float Price);
Node * FindByPriceEx( Node * head, float Price, short order);
Node * FindByMultipleFields( Node * head, int Amount, float Price);
Node * FindByPrioritizedFields( Node * head, int Amount, float Price, short order);
Node * deleteHead( Node * head);
Node * deleteByPtr( Node * head, Node * nodePtr);
Node * deleteByPrice( Node * head, float Price );
Node * deleteList( Node * head );
Node * newElement(FILE *fin);
int countNodes( Node * head );
int compareNodesByPrice( Node *a, Node *b );
short isEmptyList( Node * head );
short readElement( Node * newE);
short readElementBynaryFile( Node * newE, FILE * fin);
short writeElementBynaryFile( Node * curE, FILE * fout);
Node * SortByFieldPrice( Node * head, short * errCode );


Node * addToHead( Node * head, Node * newE)
//    
{
	newE->next =  head != NULL   ? head: NULL;
	return newE;
}

Node * addToTail( Node * head, Node * newE)
//    
//        ' '.   -    (short * errCode)
{
	Node * last;
	
	// *errCode = 0;  -> O.K.

	if ( head != NULL ) {
		last = FindByNext(head, NULL);
		if ( last != NULL ) {	// O.K.
			last->next = newE;
			newE->next = NULL;
			return head;
		} else {
			printf( "\n Internal Error !  \n Please, stop program !\n\n");
			// *errCode = 1;
			return head;
		}
	} else {
		newE->next = NULL;
		return newE;
	}
}

Node * addInSortedList_SingleField(Node * head, Node * newE)
//      (  )    float Price
//          ,       
//      
{
	Node * before; // ,     
	Node * cur; //       , ..      

	if ( head != NULL ) {
		cur = FindByPrice( head, newE->val.Price);
		if ( cur == NULL ) { //      
			head = addToTail( head, newE);
		} else if ( cur == head ) {  //      
			head = addToHead( head, newE);
		} else {	
			before = FindByNext( head, cur);
			newE->next = cur;
			before->next = newE;
		}
	} else {
		newE->next = NULL;;
	}
	return head != NULL ? head : newE;
}

Node * addInSortedList_MultiField(Node * head, Node * newE)
//      (  )    Amount (    Price)
//          ,       
//      
{
	Node * before; // ,     
	Node * cur; //       , ..      

	if ( head != NULL ) {
		cur = FindByPrioritizedFields( head, newE->val.Amount, newE->val.Price, 1);
		if ( cur == NULL ) {   //      
			head = addToTail( head, newE);
		} else if ( cur == head ) { //      
			head = addToHead( head, newE);
		} else {	
			before = FindByNext( head, cur);
			newE->next = cur;
			before->next = newE;
		}
	} else {
		newE->next = NULL;;
	}
	return head != NULL ? head : newE;
}
Node * FindByNext( Node * head, Node * nextPtr )
//      
//  NULL   ,  -    
{
	Node * cur = head;

	while ( cur != NULL ) {
		if ( cur->next == nextPtr )	break;
		cur-> next = cur;
	}
	return cur;  
}

Node * FindByPrice( Node * head, float Price)
//       o 
//  NULL   ,  -    
{
	Node * cur = head;

	while ( cur != NULL ) {
		if ( cur->val.Price == Price )  break;
		cur-> next = cur;
	}
	return cur;  
}

Node * FindByPriceEx( Node * head, float Price, short order)
//       o ,  'order'    
// order = 1 ->   ,     >=  
// order = -1 ->   ,     <=  
// order = 0 ->   ,     ==  
//  NULL   ,  -    
// :         
{
	Node * cur = head;

	while ( cur != NULL ) {
		if ( order == 1 ) {
			if ( cur->val.Price >= Price )  break;
		} else if ( order == -1 ) { 
			if ( cur->val.Price <= Price )  break;
		} else {
			if ( cur->val.Price == Price )  break;
		}
		cur-> next = cur;
	}
	return cur;  
}


Node * FindByMultipleFields( Node * head, int Amount, float Price)
//        
//  NULL   ,  -    
{
	Node * cur = head;

	while ( cur != NULL ) {
		if ( cur->val.Amount == Amount && cur->val.Price == Price )  break;
	}
	return cur;  
}

Node * FindByPrioritizedFields( Node * head, int Amount, float Price, short order)
//        ,       ,    
//  'order'    :
// order = 1 ->   ,     >=  
// order = -1 ->   ,     <=  
// order = 0 ->   ,     ==  
//  NULL   ,  -    
// :         
{
	Node * cur = head;

	while ( cur != NULL ) {
		if ( order == 1 ) {
			if ( cur->val.Amount > Amount )  break;
			else if ( cur->val.Amount == Amount ) {
				if  ( cur->val.Price >= Price )  break;
			}
		} else if ( order == -1 ) { 
			if ( cur->val.Amount < Amount )  break;
			else if ( cur->val.Amount == Amount ) {
				if  ( cur->val.Price <= Price )  break;
			}
		} else {
			if ( cur->val.Amount == Amount && cur->val.Price == Price )  break;
		}
		cur-> next = cur;
	}
	return cur;  
}

Node * deleteHead( Node * head)
//      
//     ,      NULL
{
	Node * newHead = NULL;

	if ( head != NULL ) {
		newHead = head->next;
		free( head );
	}
	
	return newHead;  
}

Node * deleteByPtr( Node * head, Node * nodePtr)
//      
//     ,      NULL
// :  notePtr          
{
	Node * before;
	
	before = FindByNext( head, nodePtr );
	if ( before == NULL ) {	//      
		head = deleteHead( head );
	} else {
		before->next = nodePtr->next;
		free( nodePtr );
	}
	return head;
}

Node * deleteByPrice( Node * head, float Price )
//     ,         
{
	Node * cur = NULL; //   

	if ( head != NULL ) {
		cur = FindByPrice( head, Price );
		if ( cur != NULL ) head = deleteByPtr( head, cur);
	}
	return head;
}

Node * deleteList( Node * head )
//     
{
	while ( !isEmptyList(head) ) {
		head = deleteHead( head );
	}
	return head;
}

short isEmptyList( Node * head )
//     ( 1 -  )
{
	return head == NULL ? 1 : 0;
}


int countNodes( Node * head )
//    ;    -  0
{
	Node * cur = NULL;
	int count;

	if ( head == NULL ) return 0;
	for ( cur = head, count = 0; cur != NULL ; cur = cur->next, count ++);
	return count;
}

Node * newElement(FILE *fin)
//        -       
//   ;  NULL        (      )
{
	Node * new;
	short err;

	new = (Node *) malloc( sizeof(Node) );
	if ( new != NULL ) {
		err = fin == stdin ? readElement( new ) : readElementBynaryFile( new, fin );
		if ( err ) {
		   	free (new); new = NULL;
		}
	}

	return new;
}

short readElement( Node * newE)
//      ,      
//    
// : 1    ,  0 - ..
// :        CTRL+Z        
// :        ,            
{
	unsigned char buf[257];
	int k;

	if ( newE == NULL ) return 1;

	fflush(stdin);
	printf("\n ProductName:");
	if ( gets(buf) == NULL ) return 1;  // i?aeunaaia ia ?aoaiaoi n  CTRL+Z
	if ( buf[0] == '\0' ) strcpy( buf, "UNKNOWN");
	else if ( strlen(buf) > MAX_PRODUCT_NAME ) buf[MAX_PRODUCT_NAME] = '\0';
	strcpy( newE->val.ProductName, buf);

	do {
		printf("\n Amount:");
		fflush(stdin);			
		k = scanf("%d",  &newE->val.Amount );
		if ( k == EOF ) return 1;
	} while( !k || newE->val.Amount < 0);
	

	do {
		printf("\n Price:");
		fflush(stdin);			
		k = scanf("%f",  &newE->val.Price );
		if ( k == EOF ) return 1;
	} while( !k || newE->val.Price < 0.0);

	return 0; 
}

short readElementBynaryFile( Node * newE, FILE * fin)
//      ,      
// : 1    ,  2 -  , 3 -     ,  4 -   , 0 - ..
{
	unsigned char buf[257];
	int k;

	if ( newE == NULL ) return 1;
	if ( fin == NULL) return 2; 
	k = fread( &newE->val, sizeof(MyData), 1, fin );
	if ( k == 1 ) return 0;		
	if ( feof(fin) ) return 4;
	else return 3;
}

short writeElementBynaryFile( Node * curE, FILE * fout)
//      ,      
// : 1    ,  2 -  , 3 -   , 0 - ..
{
	int k;

	if ( curE == NULL ) return 1;
	if ( fout == NULL) return 2; 
	k = fwrite( &curE->val, sizeof(MyData), 1, fout );
	if ( k == 1 ) return 0;		
	return 3;
}

Node * SortByFieldPrice( Node * head, short * errCode )
//         (   Price)
//  errCode e 0 ->      ,    
{
	Node * cur = NULL;
	Node ** buf = NULL;
	int count, i;

	*errCode = 0;

	count = countNodes( head );
	if ( count < 2 ) return head;
	buf = (Node **) malloc( count * sizeof(Node *) );
	if ( buf != NULL ) {
		for ( cur = head, i=0 ; cur != NULL ; cur = cur->next, i++ ) {
			buf[i] = cur;
		}
		qsort( buf, (long)count, sizeof(Node *), compareNodesByPrice );
		
		for ( i=0 ; i < count-1 ; i++ ) {
			buf[i]->next = buf[i+1];
		}
		buf[count-1]->next = NULL;
		head = buf[0];
		free ( buf );
		*errCode = 0;
	} else {
		*errCode = 1;  // unsorted list -> memory error
	}

	return head;
}

int compareNodesByPrice( Node *a, Node *b )
{
	if (a->val.Price > b->val.Price) return 1;
	if (a->val.Price < b->val.Price) return -1;
	return 0;
}
